class DGraph {
  int FindMax_r (int a, int b);
public:
  int n;
  int e[N][N];
  int w[N][N];
  int di[N];
  int way[N];
  int f[N];
  int spo[N];
  int nway;
  
  DGraph (int n_);
  
  void E (int a, int b, int c) { e[a][b]=e[b][a] = c; }
  void D (int a, int b, int c) { e[a][b] = c; }
  
  int E (int a, int b) { return e[a][b] || e[b][a]; }
  int D (int a, int b) { return e[a][b]; }
  
  int FindMin (int a, int b);
  int FindMax (int a, int b);
  int FindMaxNav (int a, int b);
  int FindMinW (int a, int b);
  
  int spojny (int a);
  int spojny_r (int a);
};

DGraph::DGraph (int n_) {
  n=n_;
  for (int x=n; x--;) {
    for (int y=n; y--;) {
      e[x][y]=0;
      w[x][y]=1;
    }
  }
}

int DGraph::spojny_r (int a) {
  int b;
  trace[a]=1;
  for (b=n; b--;) {
    if (!trace[b] && E(a,b)) {
      spojny_r(b);  
    }
  }
}

int DGraph::spojny (int a) {
  for (int i=n; i--;) {
    trace[i]=0;
  }
  spojny_r(a);
}

