#include "stdio.h"

#define N 1000

bool L[N][N];
int D[N][N];
int NO[N][N];
int X,Y;

int readlabir () {
  scanf("%d %d\n",&X,&Y);
  for (int y=0; y<X; y++) {
    for (int x=0; x<X; x++) {
      L[x][y]=(getchar()=='.');
    }
    getchar();
  }
/*
  for (int y=0; y<X; y++) {
    for (int x=0; x<X; x++) {
      printf("%c","#."[L[x][y]]);
    }
    printf("\n");
  }
*/
}

#define LL(x,y) ( 0<=(x) && (x)<X && 0<=(y) && (y)<Y && L[x][y] && D[x][y]<0 )

int maxfrom (int x_, int y_) {
  int head=0,tail=0;
  int qx[N*N+1],qy[N*N+1];
  for (int y=0; y<X; y++) {
    for (int x=0; x<X; x++) {
      D[x][y]=-1;
    }
  }
  qx[tail]=x_;
  qy[tail]=y_;
  D[x_][y_]=0;
  tail++;
  int d;
  while (head!=tail) {
    int x,y;
    x=qx[head];
    y=qy[head];
    d=D[x][y];
    head++;
/*
printf("%d %d %d  ",d,x,y);
for (int i=head; i<tail; i++) {
  printf("%d,%d ",qx[i],qy[i]);
}
printf("\n");
*/
    d++;
    if (LL(x,y+1)) {
      D[x][y+1]=d;
      qx[tail]=x;
      qy[tail]=y+1;
      tail++;
    }
    if (LL(x,y-1)) {
      D[x][y-1]=d;
      qx[tail]=x;
      qy[tail]=y-1;
      tail++;
    }
    if (LL(x+1,y)) {
      D[x+1][y]=d;
      qx[tail]=x+1;
      qy[tail]=y;
      tail++;
    }
    if (LL(x-1,y)) {
      D[x-1][y]=d;
      qx[tail]=x-1;
      qy[tail]=y;
      tail++;
    }
  }
  d--;
  for (int y=0; y<X; y++) {
    for (int x=0; x<X; x++) {
      if (D[x][y]!=d && D[x][y]!=-1) {
        NO[x][y]=1;
printf(".");fflush(stdout);
      } 
    }
  }
  return d;
}

int labir () {
  int max=0;
  int a;
  for (int y=0; y<X; y++) {
    for (int x=0; x<X; x++) {
      NO[x][y]=0;
    }
  }
  for (int y=0; y<X; y++) {
    for (int x=0; x<X; x++) {
      if (L[x][y] && !NO[x][y]) {
        a=maxfrom(x,y);
        if (max<a) max=a;
      }
    }
  }
  return max;   
}

int main () {
  int T;
  scanf("%d\n",&T);
  while (T--) {
    readlabir();    
    printf("Maximum rope length is %d.\n",labir());
  }      
  return 0;
}

