#include "stdio.h"
#include "math.h"

double sqr(double x) {
  return x*x;
}

double calc(double a,double b,double c) {
  double delta;
  
  delta=sqrt(sqr(b)-4*a*c);
  return (-b-delta)/(2*a);
}


int doit(int x1,int y1, int x2, int y2) {
//  printf("[%d %d %d %d]\n",x1,y1,x2,y2);

  if ((x1>=x2) && (y1>=y2)) {
    return 1;
  }    

  if ((x1<x2) && (y1<y2)) {
    return 0;
  }    
  
//  printf("dupa\n");
  
  double y0,x0;
  double r=sqr((double)x2/2.0)+sqr((double)y2/2.0);
  double a=x1/2.0;
  double b=y1/2.0;
  
  if (r>sqr(a)+sqr(b)) return 0;
  
  y0=calc(1,-2*b,sqr(b)-r+sqr(a));
  x0=calc(1,-2*a,sqr(a)-r+sqr(b));
  
  if ((x0<0)||(y0<0)) return 0;
  double dl=sqrt(sqr(x0)+sqr(y0));
  if (floor(dl*1000+0.5)<(x2*1000)) return 0;
  else return 1;

}



int main () {
  int T;
  int x1,y1,x2,y2;
  scanf("%d\n",&T);
  while (T--) {
    scanf("%d %d %d %d\n",&x1,&y1,&x2,&y2);

    int pom;
    if (x2>y2) {
      pom=x2;
      x2=y2;
      y2=pom;
    }
    if (x1>y1) {
      pom=x1;
      x1=y1;
      y1=pom;
    }
//  printf("[%d %d %d %d]\n",x1,y1,x2,y2);    
    if (doit(x1,y1,x2,y2))
      printf("Escape is possible.\n");
    else 
      printf("Box cannot be dropped.\n");  
  }      

  return 0;
}

