#include <stdio.h>

struct code {
   long long int r,i;
};

code operator / (code &x, code &b) {
   code ret;
   long long d = b.r*b.r+b.i*b.i;
   ret.r = (x.r*b.r+x.i*b.i)/d;
   ret.i = (-x.r*b.i+x.i*b.r)/d;
   return ret;
}

code operator % (code &x, code &b) {
   code ret;
   long long d = b.r*b.r+b.i*b.i;
   ret.r = (x.r*b.r+x.i*b.i+d)%d;
   ret.i = (-x.r*b.i+x.i*b.r+d)%d;
   return ret;
}

code operator + (code &x, code &b) {
   code ret;
   ret.r = x.r+b.r;
   ret.i = b.i+x.i;
   return ret;
}

code operator - (code &x, code &b) {
   code ret;
   ret.r = x.r-b.r;
   ret.i = x.i-b.i;
   return ret;
}


code operator * (code &x, code &b) {
   code ret;
   ret.r = x.r*b.r-x.i*b.i;
   ret.i = x.r*b.i+x.i*b.r;
   return ret;
}

code B;

int calc (long long *digs, code Q, code X) {
   code a;
   a = X/Q;
   digs[1] = -1;
   if (a.i || a.r<0)
      return -1;
   if (a.r*a.r>B.r*B.r+B.i*B.i)
      return 0;
   *digs = a.r;
   if (Q.r==1 && Q.i==0)
      return 1;
   switch (calc(digs+1,Q/B,X-a*Q)) {
      case 1:	return 1;
      case 0:	a.r++; *digs = a.r; return calc(digs+1,Q/B,X-a*Q);
      default:  return -1;
   }
}

int main () {
   int Count;
   long long int digs[100];
   int num;
   code X,Q;
   scanf ("%i",&Count);
   while (Count--) {
      scanf ("%lli %lli %lli %lli", &X.r, &X.i, &B.r, &B.i);
      num = 0;
      Q = B;
      while (Q.r*Q.r+Q.i*Q.i<=X.r*X.r+X.i*X.i)
         Q = Q*B;
      num = calc (digs,Q,X);
      if (num==1)
         for (num=0; digs[num]>=0; num++) {
            printf ("%lli",digs[num]);
     	    if (digs[num+1]>=0)
	       printf (",");
         }
      else
         printf ("The code cannot be dectypted.");
      printf ("\n");
   }
   return 0;
}
