#include <stdio.h>
#include <mem.h>

int keyX,keyY;
char key[100][100];
int dX,dY;

char Rlines[101][1001];
char *lines[101];
char fit[101];

void readkey () {
   int x,y;
   scanf ("%i %i",&keyY,&keyX);
   getchar ();
   for (y=0; y<keyY; y++) {
      for (x=0; x<keyX; x++)
         key[y][x] = (getchar()=='#');
      getchar ();
   }
   scanf ("%i %i",&dY,&dX);
   for (y=0; y<keyY; y++) {
      lines[y] = Rlines[y];
      memset (lines[y], 0, dX);
   }
}

void printkey () {
   int x,y;
   for (y=0; y<keyY; y++) {
      for (x=0; x<keyX; x++)
         putchar (key[y][x] ? '#' : '.');
      putchar ('\n');
   }
}

bool test1 (int X) {
   int x,y;
   getchar ();
   for (x=0; x<keyX; x++) {
      lines[keyY-1] = getchar()=='#';
      for (y=0; y<keyY; y++)
         if (lines[y][x+X] && key[y][x])
	    return false;
   }
   return true;
}

bool test () {
   int x;
   bool ok;
   ok = false;
   for (x=0; x<dX-keyX+1; x++)
      fit[x] = test1(x);
   for (x=0; x<dX-keyX+1; x++)
      ok |= (lines[keyY][x] = fit[x] && lines[keyY-1]);
   for (x=1; x<dX-keyX+1; x++)
      ok |= (lines[keyY][x] |= lines[keyY][x-1] && fit[x]);
   for (x=dX-keyX-1; x; x--)
      ok |= (lines[keyY][x] |= lines[keyY][x+1] && fit[x]);
   return ok;
}

bool shift () {
   int y;
   if (!dY--)
      return false;
   for (y=1; y<keyY-1; y++)
      lines[y-1] = lines[y];
   
   return true;
}

int main () {
   int CNT;
   int drop;
   scanf ("%i",&CNT);
   while (CNT--) {
      readkey ();
      drop = 0;
      while (1) {
        if (!test()) {
	   printf ("Key falls to depth %i.\n",drop);
	   break;
	}
	if (!shift()) {
	   printf ("The key can fall through.\n");
	   break;
	}
      }
   }
   return 0;
}

	
   }
   return 0;
}
