#include "stdio.h"
#include "string.h"


#define N 1000000

int n;
int F[N];
int x[N],y[N];
int xm[N],ym[N];  // razy 3 !


void pr (long long x) {
  long long d;
  double m;
  char s[100];
  if (x<0) {
    printf("-");
    x=-x;
  }
  d=x/1000LL;
  printf("%lld.",d);
  m=(x%1000LL)/1000.0;
  sprintf(s,"%.2f",m+1e-10);
  printf("%s",s+2);
}


long prod (int i, int j) {
  return x[i]*y[j]-x[j]*y[i];
}


int poly () {
  long long sumFx,sumFy,sumF;
  long long ax,ay;
  int axd,ayd,axm,aym;
  scanf("%d\n",&n);
  for (int i=0; i<n; i++) {
    scanf("%d %d\n",x+i,y+i);
  }
  for (int i=1; i<n; i++) {
    F[i]=prod(i-1,i);
    xm[i]=x[i]+x[i-1];
    ym[i]=y[i]+y[i-1];
  }
  F[0]=prod(n-1,0);
  xm[0]=x[0]+x[n-1];
  ym[0]=y[0]+y[n-1];
  sumFx=0;
  sumFy=0;
  sumF=0;
  for (int i=0; i<n; i++) {
//printf("%d ",F[i]);
    sumFx+=F[i]*xm[i];
    sumFy+=F[i]*ym[i];
    sumF+=F[i];
  }
//printf("\n");
  sumF*=3;
  ax=sumFx*1000;
  ax/=sumF;
  ay=sumFy*1000;
  ay/=sumF;
  pr(ax);
  printf(" ");
  pr(ay);
  printf("\n");
}

int main () {
  int T;
  scanf("%d\n",&T);
  while (T--) {
    poly();
  }      
  return 0;
}

